'
' ####################
' #####  PROLOG  #####
' ####################
'
' Call ExitWindowsEx to reboot windows.
'
VERSION "0.0001"
'CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

	IMPORT "gdi32"			' gdi32.dll
	IMPORT "user32"		  ' user32.dll
	IMPORT "kernel32"	  ' kernel32.dll
	IMPORT "advapi32"

DECLARE FUNCTION Entry ()
DECLARE FUNCTION AdjustToken ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	answer = MessageBoxA (0, &"Are you sure you want to Restart Windows?", &"Restarting Windows", $$MB_YESNO | $$MB_SYSTEMMODAL | $$MB_ICONEXCLAMATION | $$MB_DEFBUTTON2)

	IF answer = $$IDYES THEN
		XstGetOSVersion (@major, @minor, @platformId, @version$, @platform$) 
		IF platformId = $$VER_PLATFORM_WIN32_NT THEN AdjustToken ()
		
		IFZ ExitWindowsEx ($$EWX_REBOOT | $$EWX_FORCE | $$EWX_SHUTDOWN, $$SHTDN_REASON_MAJOR_SOFTWARE | $$SHTDN_REASON_MINOR_INSTALLATION) THEN
			msg$ = "An application refused to quit. Error: " + STRING$(GetLastError()) + $$CRLF$ + "Please check all running applications." 
			MessageBoxA (0, &msg$, &"ExitWindowsEx error", $$MB_OK)
		END IF
	END IF

END FUNCTION

FUNCTION AdjustToken ()

	LUID luid 
	TOKEN_PRIVILEGES tkp
	
	hdlProcessHandle = GetCurrentProcess()
	OpenProcessToken (hdlProcessHandle, $$TOKEN_ADJUST_PRIVILEGES | $$TOKEN_QUERY, &token)

	' Get the LUID for shutdown privilege.
	LookupPrivilegeValueA (NULL, &"SeShutdownPrivilege", &luid)
	
	tkp.PrivilegeCount = 1 ' Set one privilege
	tkp.Privileges[0].Luid = luid
	tkp.Privileges[0].Attributes = $$SE_PRIVILEGE_ENABLED
	
	' Enable the shutdown privilege in the access token of this process.
	
	AdjustTokenPrivileges (token, 0, &tkp, 0, NULL, NULL)


END FUNCTION
END PROGRAM